precision highp float;

uniform vec3 scaler; 
uniform vec3 transer;
uniform float pitch;
uniform float yaw;
uniform float roll;
attribute vec3 vPosition;
attribute vec2 vTex_coord;
varying vec2 tex_coord;


mat4 rotationMatrix(vec3 axis, float angle) {
 axis = normalize(axis);
 float s = sin(angle);
 float c = cos(angle);
 float oc = 1.0 - c;
    
 return mat4(
  oc * axis.x * axis.x + c,          
  oc * axis.x * axis.y - axis.z * s,  
  oc * axis.z * axis.x + axis.y * s, 
  0.0,
  oc * axis.x * axis.y + axis.z * s, 
  oc * axis.y * axis.y + c,    
  oc * axis.y * axis.z - axis.x * s,  
  0.0,
  oc * axis.z * axis.x - axis.y * s,  
  oc * axis.y * axis.z + axis.x * s,
  oc * axis.z * axis.z + c,    
  0.0, 
  0.0, 
  0.0, 
  0.0,
  1.0);
}


void main() {
 vec4 pos;
 mat4 matrix1, matrix2, matrix3;
 matrix1 = rotationMatrix(vec3(1.0, 0.0, 0.0), pitch);
 matrix2 = rotationMatrix(vec3(0.0, 1.0, 0.0), yaw);
 matrix3 = rotationMatrix(vec3(0.0, 0.0, 1.0), roll);

 pos = vec4(vPosition,1.0) * matrix1 * matrix2 *matrix3;

 gl_Position = vec4((pos.xyz* scaler)+transer, 1.0); 
 tex_coord = vTex_coord; 
} 

